searchNodes=[{"ref":"Slack.html","title":"Slack","type":"module","doc":"A client for the Slack API. This library exports a module for each namespace on the Slack API. For each method in that namespace, a function is exported from its parent module. Nested namespaces are in nested modules. When looking at the Slack API documentation, if you see a method called usergroups.users.list, you know that you can call this API method with the function call Slack.UserGroup.User.list. Note that all module names are singular, regardless of whether they are singular or plural in the Slack API. Authentication For Slack API endpoints that require an authentication token (which is all of them save some special OAuth endpoints), a Slack.Client.t must be passed in as the first argument to a function call: access_token |&gt; Slack.client # Creates a new `Slack.Client.t` |&gt; Slack.Channel.list While the typespec currently expects a Slack.Client.t, anything can technically passed in on which the function can call client.token. Request Methods The Slack API allows clients to either issue GET or POST requests for any API method. In this client, POST is used whenever the request can potentially create or change data. Otherwise, a GET is used. Return Values For any successful method, the Slack API returns a key &quot;okay&quot; in the response body with true as the value. When handling a response, this library checks for this value and if it is present, returns {:ok, response_body}. An HTTPoison.Response.t is only returned when a method call fails, in a tuple: {:error, response}. Arbitrary Request To make some arbitrary request that is not in this library, you can use special HTTP methods on the Slack module: {:ok, response} = Slack.get &quot;namespace.method&quot;, [], params: [token: access_token]"},{"ref":"Slack.html#client/1","title":"Slack.client/1","type":"function","doc":""},{"ref":"Slack.html#delete/3","title":"Slack.delete/3","type":"function","doc":"Issues a DELETE request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"Slack.html#delete!/3","title":"Slack.delete!/3","type":"function","doc":"Issues a DELETE request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"Slack.html#get/3","title":"Slack.get/3","type":"function","doc":"Issues a GET request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"Slack.html#get!/3","title":"Slack.get!/3","type":"function","doc":"Issues a GET request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"Slack.html#head/3","title":"Slack.head/3","type":"function","doc":"Issues a HEAD request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"Slack.html#head!/3","title":"Slack.head!/3","type":"function","doc":"Issues a HEAD request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"Slack.html#options/3","title":"Slack.options/3","type":"function","doc":"Issues an OPTIONS request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"Slack.html#options!/3","title":"Slack.options!/3","type":"function","doc":"Issues a OPTIONS request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"Slack.html#patch/4","title":"Slack.patch/4","type":"function","doc":"Issues a PATCH request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"Slack.html#patch!/4","title":"Slack.patch!/4","type":"function","doc":"Issues a PATCH request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"Slack.html#post/4","title":"Slack.post/4","type":"function","doc":"Issues a POST request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"Slack.html#post!/4","title":"Slack.post!/4","type":"function","doc":"Issues a POST request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"Slack.html#process_headers/1","title":"Slack.process_headers/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_headers/1."},{"ref":"Slack.html#process_request_body/1","title":"Slack.process_request_body/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_body/1."},{"ref":"Slack.html#process_request_headers/1","title":"Slack.process_request_headers/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_headers/1."},{"ref":"Slack.html#process_request_options/1","title":"Slack.process_request_options/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_options/1."},{"ref":"Slack.html#process_request_params/1","title":"Slack.process_request_params/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_params/1."},{"ref":"Slack.html#process_request_url/1","title":"Slack.process_request_url/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_url/1."},{"ref":"Slack.html#process_response/1","title":"Slack.process_response/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response/1."},{"ref":"Slack.html#process_response_body/1","title":"Slack.process_response_body/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_body/1."},{"ref":"Slack.html#process_response_chunk/1","title":"Slack.process_response_chunk/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_chunk/1."},{"ref":"Slack.html#process_response_headers/1","title":"Slack.process_response_headers/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_headers/1."},{"ref":"Slack.html#process_response_status_code/1","title":"Slack.process_response_status_code/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_status_code/1."},{"ref":"Slack.html#process_status_code/1","title":"Slack.process_status_code/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_status_code/1."},{"ref":"Slack.html#process_url/1","title":"Slack.process_url/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_url/1."},{"ref":"Slack.html#put/4","title":"Slack.put/4","type":"function","doc":"Issues a PUT request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"Slack.html#put!/4","title":"Slack.put!/4","type":"function","doc":"Issues a PUT request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"Slack.html#request/1","title":"Slack.request/1","type":"function","doc":"Issues an HTTP request using a Request struct. This function returns {:ok, response} or {:ok, async_response} if the request is successful, {:error, reason} otherwise. Examples request = %HTTPoison.Request{ method: :post, url: &quot;https://my.website.com&quot;, body: &quot;{\\&quot;foo\\&quot;: 3}&quot;, headers: [{&quot;Accept&quot;, &quot;application/json&quot;}] } request(request)"},{"ref":"Slack.html#request/5","title":"Slack.request/5","type":"function","doc":"Issues an HTTP request with the given method to the given url. This function is usually used indirectly by get/3, post/4, put/4, etc Args: method - HTTP method as an atom (:get, :head, :post, :put, :delete, etc.) url - target url as a binary string or char list body - request body. See more below headers - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}]) options - Keyword list of options Body: see type HTTPoison.Request Options: see type HTTPoison.Request This function returns {:ok, response} or {:ok, async_response} if the request is successful, {:error, reason} otherwise. Examples request(:post, &quot;https://my.website.com&quot;, &quot;{\\&quot;foo\\&quot;: 3}&quot;, [{&quot;Accept&quot;, &quot;application/json&quot;}])"},{"ref":"Slack.html#request!/5","title":"Slack.request!/5","type":"function","doc":"Issues an HTTP request with the given method to the given url, raising an exception in case of failure. request!/5 works exactly like request/5 but it returns just the response in case of a successful request, raising an exception in case the request fails."},{"ref":"Slack.html#start/0","title":"Slack.start/0","type":"function","doc":"Starts HTTPoison and its dependencies."},{"ref":"Slack.html#stream_next/1","title":"Slack.stream_next/1","type":"function","doc":"Requests the next message to be streamed for a given HTTPoison.AsyncResponse. See request!/5 for more detailed information."},{"ref":"Slack.html#t:body/0","title":"Slack.body/0","type":"type","doc":""},{"ref":"Slack.html#t:headers/0","title":"Slack.headers/0","type":"type","doc":""},{"ref":"Slack.html#t:options/0","title":"Slack.options/0","type":"type","doc":""},{"ref":"Slack.html#t:params/0","title":"Slack.params/0","type":"type","doc":""},{"ref":"Slack.html#t:request/0","title":"Slack.request/0","type":"type","doc":""},{"ref":"Slack.html#t:response/0","title":"Slack.response/0","type":"type","doc":""},{"ref":"Slack.html#t:slack_response/0","title":"Slack.slack_response/0","type":"type","doc":""},{"ref":"Slack.html#t:url/0","title":"Slack.url/0","type":"type","doc":""},{"ref":"Slack.API.html","title":"Slack.API","type":"module","doc":"Functions for checking calling code"},{"ref":"Slack.API.html#test/2","title":"Slack.API.test/2","type":"function","doc":"\b\bTest calling code. https://api.slack.com/methods/api.test Examples Slack.client(token) |&gt; Slack.API.test(foo: &quot;bar&quot;)"},{"ref":"Slack.Auth.html","title":"Slack.Auth","type":"module","doc":"Functions for dealing with access tokens"},{"ref":"Slack.Auth.html#revoke/2","title":"Slack.Auth.revoke/2","type":"function","doc":"Revoke an access token. https://api.slack.com/methods/auth.revoke Examples Slack.client(token) |&gt; Slack.Auth.revoke"},{"ref":"Slack.Auth.html#test/2","title":"Slack.Auth.test/2","type":"function","doc":"Check and identity an access token. https://api.slack.com/methods/auth.test Examples Slack.client(token) |&gt; Slack.Auth.test"},{"ref":"Slack.Bot.html","title":"Slack.Bot","type":"module","doc":"Functions for getting information about bots"},{"ref":"Slack.Bot.html#info/2","title":"Slack.Bot.info/2","type":"function","doc":"Get info for a bot. https://api.slack.com/methods/bots.info Examples Slack.client(token) |&gt; Slack.Bot.info(bot: &quot;B12345678&quot;)"},{"ref":"Slack.Channel.html","title":"Slack.Channel","type":"module","doc":"\b\bA publicly listed communication channel in a team"},{"ref":"Slack.Channel.html#archive/2","title":"Slack.Channel.archive/2","type":"function","doc":"\b\bArchive a channel. https://api.slack.com/methods/channels.archive Examples Slack.client(token) |&gt; Slack.Channel.archive(channel: &quot;C1234567890&quot;)"},{"ref":"Slack.Channel.html#create/2","title":"Slack.Channel.create/2","type":"function","doc":"\b\bCreate a channel. https://api.slack.com/methods/channels.create Examples Slack.client(token) |&gt; Slack.Channel.create(name: &quot;mychannel&quot;)"},{"ref":"Slack.Channel.html#history/2","title":"Slack.Channel.history/2","type":"function","doc":"\b\bRetrieve channel history. https://api.slack.com/methods/channels.history Examples Slack.client(token) |&gt; Slack.Channel.history(channel: &quot;C1234567890&quot;)"},{"ref":"Slack.Channel.html#info/2","title":"Slack.Channel.info/2","type":"function","doc":"\b\bGet channel info. https://api.slack.com/methods/channels.info Examples Slack.client(token) |&gt; Slack.Channel.info(channel: &quot;C1234567890&quot;)"},{"ref":"Slack.Channel.html#invite/2","title":"Slack.Channel.invite/2","type":"function","doc":"\b\bInvite a user to a channel. https://api.slack.com/methods/channels.invite Examples Slack.client(token) |&gt; Slack.Channel.invite(channel: &quot;C1234567890&quot;, user: &quot;U1234567890&quot;)"},{"ref":"Slack.Channel.html#join/2","title":"Slack.Channel.join/2","type":"function","doc":"\b\bJoin a channel. https://api.slack.com/methods/channels.join Examples Slack.client(token) |&gt; Slack.Channel.join(channel: &quot;C1234567890&quot;)"},{"ref":"Slack.Channel.html#kick/2","title":"Slack.Channel.kick/2","type":"function","doc":"Kick a user from a channel. https://api.slack.com/methods/channels.kick Examples Slack.client(token) |&gt; Slack.Channel.kick(channel: &quot;C1234567890&quot;, user: &quot;U1234567890&quot;)"},{"ref":"Slack.Channel.html#leave/2","title":"Slack.Channel.leave/2","type":"function","doc":"Leave a channel. https://api.slack.com/methods/channels.leave Examples Slack.client(token) |&gt; Slack.Channel.leave(channel: &quot;C1234567890&quot;)"},{"ref":"Slack.Channel.html#list/2","title":"Slack.Channel.list/2","type":"function","doc":"\b\bList all of the channels in a team. https://api.slack.com/methods/channels.list Examples Slack.client(token) |&gt; Slack.Channel.list"},{"ref":"Slack.Channel.html#mark/2","title":"Slack.Channel.mark/2","type":"function","doc":"Move the read cursor in a channel. https://api.slack.com/methods/channels.mark Examples Slack.client(token) |&gt; Slack.Channel.mark(channel: &quot;C1234567890&quot;, ts: &quot;1234567890.123456&quot;)"},{"ref":"Slack.Channel.html#rename/2","title":"Slack.Channel.rename/2","type":"function","doc":"Rename a channel. https://api.slack.com/methods/channels.rename Examples Slack.client(token) |&gt; Slack.Channel.rename(channel: &quot;C1234567890&quot;, name: &quot;newname&quot;)"},{"ref":"Slack.Channel.html#setPurpose/2","title":"Slack.Channel.setPurpose/2","type":"function","doc":"Set the purpose of a channel. https://api.slack.com/methods/channels.setPurpose Examples Slack.client(token) |&gt; Slack.Channel.setPurpose(channel: &quot;C1234567890&quot;, purpose: &quot;Purpose&quot;)"},{"ref":"Slack.Channel.html#setTopic/2","title":"Slack.Channel.setTopic/2","type":"function","doc":"Set the topic of a channel. https://api.slack.com/methods/channels.setTopic Examples Slack.client(token) |&gt; Slack.Channel.setTopic(channel: &quot;C1234567890&quot;, topic: &quot;Topic&quot;)"},{"ref":"Slack.Channel.html#unarchive/2","title":"Slack.Channel.unarchive/2","type":"function","doc":"\bUnarchive a channel. https://api.slack.com/methods/channels.unarchive Examples Slack.client(token) |&gt; Slack.Channel.unarchive(channel: &quot;C1234567890&quot;)"},{"ref":"Slack.Chat.html","title":"Slack.Chat","type":"module","doc":"Functions for handling channel messages"},{"ref":"Slack.Chat.html#delete/2","title":"Slack.Chat.delete/2","type":"function","doc":"Delete a chat message. https://api.slack.com/methods/chat.delete Examples Slack.client(token) |&gt; Slack.Chat.delete(channel: &quot;C1234567890&quot;, ts: &quot;1405894322.002768&quot;)"},{"ref":"Slack.Chat.html#meMessage/2","title":"Slack.Chat.meMessage/2","type":"function","doc":"Send a &quot;me message&quot; to a channel. https://api.slack.com/methods/chat.meMessage Examples Slack.client(token) |&gt; Slack.Chat.meMessage(channel: &quot;C1234567890&quot;, text: &quot;Hello&quot;)"},{"ref":"Slack.Chat.html#postMessage/2","title":"Slack.Chat.postMessage/2","type":"function","doc":"Post a message to a channel. https://api.slack.com/methods/chat.postMessage Examples Slack.client(token) |&gt; Slack.Chat.postMessage(channel: &quot;C1234567890&quot;, text: &quot;Hello&quot;)"},{"ref":"Slack.Chat.html#update/2","title":"Slack.Chat.update/2","type":"function","doc":"Update a message in a channel. https://api.slack.com/methods/chat.update Examples Slack.client(token) |&gt; Slack.Chat.postMessage( channel: &quot;C1234567890&quot;, text: &quot;Hello&quot;, ts: &quot;1405894322.002768&quot;)"},{"ref":"Slack.Client.html","title":"Slack.Client","type":"module","doc":"A struct containing an authorization token"},{"ref":"Slack.Client.html#t:t/0","title":"Slack.Client.t/0","type":"type","doc":""},{"ref":"Slack.DND.html","title":"Slack.DND","type":"module","doc":"\b\bFunctions for working with the user&#39;s Do Not Disturb session"},{"ref":"Slack.DND.html#endDnd/2","title":"Slack.DND.endDnd/2","type":"function","doc":"\b\bEnd the user&#39;s Do Not Disturb session. https://api.slack.com/methods/dnd.endDnd Examples Slack.client(token) |&gt; Slack.DND.endDnd"},{"ref":"Slack.DND.html#endSnooze/2","title":"Slack.DND.endSnooze/2","type":"function","doc":"\b\bEnd the user&#39;s snooze mode. https://api.slack.com/methods/dnd.endSnooze Examples Slack.client(token) |&gt; Slack.DND.endSnooze"},{"ref":"Slack.DND.html#info/2","title":"Slack.DND.info/2","type":"function","doc":"Get information on the user&#39;s Do Not Disturb settings. https://api.slack.com/methods/dnd.info Examples Slack.client(token) |&gt; Slack.DND.info(user: &quot;U1234&quot;)"},{"ref":"Slack.DND.html#setSnooze/2","title":"Slack.DND.setSnooze/2","type":"function","doc":"Adjust the snooze duration for the user&#39;s Do Not Disturb settings. https://api.slack.com/methods/dnd.setSnooze Examples Slack.client(token) |&gt; Slack.DND.setSnooze(num_minutes: 30)"},{"ref":"Slack.DND.html#teamInfo/2","title":"Slack.DND.teamInfo/2","type":"function","doc":"Get information about Do Not Disturb settings for a team. https://api.slack.com/methods/dnd.teamInfo Examples Slack.client(token) |&gt; Slack.DND.teamInfo"},{"ref":"Slack.Emoji.html","title":"Slack.Emoji","type":"module","doc":"\b\bFunctions for working with a team&#39;s custom emoji"},{"ref":"Slack.Emoji.html#list/2","title":"Slack.Emoji.list/2","type":"function","doc":"\b\bList the custom emoji for a team. https://api.slack.com/methods/emoji.list Examples Slack.client(token) |&gt; Slack.Emoji.list"},{"ref":"Slack.File.html","title":"Slack.File","type":"module","doc":"\b\bFunctions for working with files in Slack"},{"ref":"Slack.File.html#delete/2","title":"Slack.File.delete/2","type":"function","doc":"Delete a file from the team. https://api.slack.com/methods/files.delete Examples Slack.client(token) |&gt; Slack.File.delete(file: &quot;F1234467890&quot;)"},{"ref":"Slack.File.html#info/2","title":"Slack.File.info/2","type":"function","doc":"Get information about a file. https://api.slack.com/methods/files.info Examples Slack.client(token) |&gt; Slack.File.info(file: &quot;F1234467890&quot;)"},{"ref":"Slack.File.html#list/2","title":"Slack.File.list/2","type":"function","doc":"List files within the team. https://api.slack.com/methods/files.list Examples Slack.client(token) |&gt; Slack.File.list"},{"ref":"Slack.File.html#revokePublicURL/2","title":"Slack.File.revokePublicURL/2","type":"function","doc":"Disable public sharing for a file. https://api.slack.com/methods/files.revokePublicURL Examples Slack.client(token) |&gt; Slack.File.revokePublicURL(file: &quot;F1234467890&quot;)"},{"ref":"Slack.File.html#sharedPublicURL/2","title":"Slack.File.sharedPublicURL/2","type":"function","doc":"Enable public sharing for a file. https://api.slack.com/methods/files.sharedPublicURL Examples Slack.client(token) |&gt; Slack.File.sharedPublicURL(file: &quot;F1234467890&quot;)"},{"ref":"Slack.File.html#upload/2","title":"Slack.File.upload/2","type":"function","doc":"Upload a file. https://api.slack.com/methods/files.upload Examples Slack.client(token) |&gt; Slack.File.upload(content: &quot;File contents&quot;)"},{"ref":"Slack.File.Comment.html","title":"Slack.File.Comment","type":"module","doc":"\b\bFunctions for working with comments on files"},{"ref":"Slack.File.Comment.html#add/2","title":"Slack.File.Comment.add/2","type":"function","doc":"Add a comment to an existing file. https://api.slack.com/methods/files.comments.add Examples Slack.client(token) |&gt; Slack.File.Comment.add(file: &quot;F1234467890&quot;, comment: &quot;Foo&quot;)"},{"ref":"Slack.File.Comment.html#delete/2","title":"Slack.File.Comment.delete/2","type":"function","doc":"Delete a comment on a file. https://api.slack.com/methods/files.comments.delete Examples Slack.client(token) |&gt; Slack.File.Comment.delete(file: &quot;F1234467890&quot;, id: &quot;Fc1234567890&quot;)"},{"ref":"Slack.File.Comment.html#edit/2","title":"Slack.File.Comment.edit/2","type":"function","doc":"Edit a comment on a file. https://api.slack.com/methods/files.comments.edit Examples Slack.client(token) |&gt; Slack.File.Comment.edit( file: &quot;F1234467890&quot;, id: &quot;Fc1234567890&quot;, comment: &quot;Hello&quot;)"},{"ref":"Slack.Group.html","title":"Slack.Group","type":"module","doc":"\b\bFunctions for working with private channels (groups)"},{"ref":"Slack.Group.html#archive/2","title":"Slack.Group.archive/2","type":"function","doc":"Archive a private channel. https://api.slack.com/methods/groups.archive Examples Slack.Group.archive(client, channel: &quot;G1234567890&quot;)"},{"ref":"Slack.Group.html#close/2","title":"Slack.Group.close/2","type":"function","doc":"Close a private channel. https://api.slack.com/methods/groups.close Examples Slack.Group.close(client, channel: &quot;G1234567890&quot;)"},{"ref":"Slack.Group.html#create/2","title":"Slack.Group.create/2","type":"function","doc":"Create a private channel. https://api.slack.com/methods/groups.create Examples Slack.Group.create(client, name: &quot;newchannel&quot;)"},{"ref":"Slack.Group.html#createChild/2","title":"Slack.Group.createChild/2","type":"function","doc":"Replace a private channel. https://api.slack.com/methods/groups.createChild Examples Slack.Group.createChild(client, channel: &quot;G1234567890&quot;)"},{"ref":"Slack.Group.html#history/2","title":"Slack.Group.history/2","type":"function","doc":"Get the history of a private channel. https://api.slack.com/methods/groups.history Examples Slack.Group.history(client, channel: &quot;G1234567890&quot;)"},{"ref":"Slack.Group.html#info/2","title":"Slack.Group.info/2","type":"function","doc":"Get the info of a private channel. https://api.slack.com/methods/groups.info Examples Slack.Group.info(client, channel: &quot;G1234567890&quot;)"},{"ref":"Slack.Group.html#invite/2","title":"Slack.Group.invite/2","type":"function","doc":"Invite a user to a private channel. https://api.slack.com/methods/groups.invite Examples Slack.Group.invite(client, channel: &quot;G1234567890&quot;, user: &quot;U1234567890&quot;)"},{"ref":"Slack.Group.html#kick/2","title":"Slack.Group.kick/2","type":"function","doc":"Kick a user from a private channel. https://api.slack.com/methods/groups.kick Examples Slack.Group.kick(client, channel: &quot;G1234567890&quot;, user: &quot;U1234567890&quot;)"},{"ref":"Slack.Group.html#leave/2","title":"Slack.Group.leave/2","type":"function","doc":"Leave a private channel. https://api.slack.com/methods/groups.leave Examples Slack.Group.leave(client, channel: &quot;G1234567890&quot;)"},{"ref":"Slack.Group.html#list/2","title":"Slack.Group.list/2","type":"function","doc":"List private channels. https://api.slack.com/methods/groups.list Examples Slack.Group.list(client)"},{"ref":"Slack.Group.html#mark/2","title":"Slack.Group.mark/2","type":"function","doc":"Move the read cursor in a private channel. https://api.slack.com/methods/groups.mark Examples Slack.Group.mark(client, channel: &quot;G1234567890&quot;, ts: 1234567890.123456)"},{"ref":"Slack.Group.html#open/2","title":"Slack.Group.open/2","type":"function","doc":"Open a private channel. https://api.slack.com/methods/groups.open Examples Slack.Group.open(client, channel: &quot;G1234567890&quot;)"},{"ref":"Slack.Group.html#rename/2","title":"Slack.Group.rename/2","type":"function","doc":"Rename a private channel. https://api.slack.com/methods/groups.rename Examples Slack.Group.rename(client, channel: &quot;G1234567890&quot;, name: &quot;newname&quot;)"},{"ref":"Slack.Group.html#setPurpose/2","title":"Slack.Group.setPurpose/2","type":"function","doc":"Set the purpose of a private channel. https://api.slack.com/methods/groups.setPurpose Examples Slack.Group.setPurpose(client, channel: &quot;G1234567890&quot;, purpose: &quot;purpose&quot;)"},{"ref":"Slack.Group.html#setTopic/2","title":"Slack.Group.setTopic/2","type":"function","doc":"Set the topic of a private channel. https://api.slack.com/methods/groups.setTopic Examples Slack.Group.setTopic(client, channel: &quot;G1234567890&quot;, topic: &quot;topic&quot;)"},{"ref":"Slack.Group.html#unarchive/2","title":"Slack.Group.unarchive/2","type":"function","doc":"Unarchive a private channel. https://api.slack.com/methods/groups.unarchive Examples Slack.Group.unarchive(client, channel: &quot;G1234567890&quot;)"},{"ref":"Slack.IM.html","title":"Slack.IM","type":"module","doc":"\b\bFunctions for direct messages"},{"ref":"Slack.IM.html#close/2","title":"Slack.IM.close/2","type":"function","doc":"Close an IM channel https://api.slack.com/methods/im.close Examples Slack.client(token) |&gt; Slack.IM.close(channel: &quot;D1234567890&quot;)"},{"ref":"Slack.IM.html#history/2","title":"Slack.IM.history/2","type":"function","doc":"Get the history of an IM channel. https://api.slack.com/methods/im.history Examples Slack.client(token) |&gt; Slack.IM.history(channel: &quot;D1234567890&quot;)"},{"ref":"Slack.IM.html#list/2","title":"Slack.IM.list/2","type":"function","doc":"List IM channels for the user. https://api.slack.com/methods/im.list Examples Slack.client(token) |&gt; Slack.IM.list"},{"ref":"Slack.IM.html#mark/2","title":"Slack.IM.mark/2","type":"function","doc":"Move the read cursor in an IM channel. https://api.slack.com/methods/im.mark Examples Slack.client(token) |&gt; Slack.IM.mark(channel: &quot;D1234567890&quot;, ts: 1234567890.123456)"},{"ref":"Slack.IM.html#open/2","title":"Slack.IM.open/2","type":"function","doc":"Open an IM channel with a user. https://api.slack.com/methods/im.open Examples Slack.client(token) |&gt; Slack.IM.open(user: &quot;U1234567890&quot;)"},{"ref":"Slack.MPIM.html","title":"Slack.MPIM","type":"module","doc":"\b\bFunctions for multiparty IMs"},{"ref":"Slack.MPIM.html#close/2","title":"Slack.MPIM.close/2","type":"function","doc":"Close a multiparty IM channel https://api.slack.com/methods/im.close Examples Slack.client(token) |&gt; Slack.IM.close(channel: &quot;G1234567890&quot;)"},{"ref":"Slack.MPIM.html#history/2","title":"Slack.MPIM.history/2","type":"function","doc":"Get the history of a multiparty IM channel. https://api.slack.com/methods/im.history Examples Slack.client(token) |&gt; Slack.IM.history(channel: &quot;G1234567890&quot;)"},{"ref":"Slack.MPIM.html#list/2","title":"Slack.MPIM.list/2","type":"function","doc":"List multiparty IM channels for the user. https://api.slack.com/methods/im.list Examples Slack.client(token) |&gt; Slack.IM.list"},{"ref":"Slack.MPIM.html#mark/2","title":"Slack.MPIM.mark/2","type":"function","doc":"Move the read cursor in a multiparty IM channel. https://api.slack.com/methods/im.mark Examples Slack.client(token) |&gt; Slack.IM.mark(channel: &quot;G1234567890&quot;, ts: 1234567890.123456)"},{"ref":"Slack.MPIM.html#open/2","title":"Slack.MPIM.open/2","type":"function","doc":"Open a multiparty IM channel with a user. https://api.slack.com/methods/im.open Examples Slack.client(token) |&gt; Slack.IM.open(user: &quot;U1234567890,U2345678901&quot;)"},{"ref":"Slack.OAuth.html","title":"Slack.OAuth","type":"module","doc":"Functions for handling OAuth code/token exchange"},{"ref":"Slack.OAuth.html#access/1","title":"Slack.OAuth.access/1","type":"function","doc":"\b\bExchange an OAuth code for a Slack API access token. https://api.slack.com/methods/oauth.access Examples Slack.OAuth.access( client_id: &quot;client_id&quot;, client_secret: &quot;client_secret&quot;, code: &quot;code&quot;)"},{"ref":"Slack.Pin.html","title":"Slack.Pin","type":"module","doc":"\b\bFunctions for working with pinned items"},{"ref":"Slack.Pin.html#add/2","title":"Slack.Pin.add/2","type":"function","doc":"Pin an item to a channel. https://api.slack.com/methods/pins.add Examples Slack.client(token) |&gt; Slack.Pin.add(channel: &quot;C1234567890&quot;, file: &quot;F1234567890&quot;)"},{"ref":"Slack.Pin.html#list/2","title":"Slack.Pin.list/2","type":"function","doc":"List pins in a channel. https://api.slack.com/methods/pins.list Examples Slack.client(token) |&gt; Slack.Pin.list(channel: &quot;C1234567890&quot;)"},{"ref":"Slack.Pin.html#remove/2","title":"Slack.Pin.remove/2","type":"function","doc":"Un-pin an item from a channel. https://api.slack.com/methods/pins.remove Examples Slack.client(token) |&gt; Slack.Pin.remove(channel: &quot;C1234567890&quot;, file: &quot;F1234567890&quot;)"},{"ref":"Slack.RTM.html","title":"Slack.RTM","type":"module","doc":"\b\bFunctions for creating Real Time Messaging API sessions"},{"ref":"Slack.RTM.html#start/2","title":"Slack.RTM.start/2","type":"function","doc":"\b\bStart an RTM API session. https://api.slack.com/methods/rtm.start Examples Slack.RTM.start(client)"},{"ref":"Slack.Reaction.html","title":"Slack.Reaction","type":"module","doc":"\b\bFunctions for working with reactions to messages 👍"},{"ref":"Slack.Reaction.html#add/2","title":"Slack.Reaction.add/2","type":"function","doc":"Add a reaction to an item. https://api.slack.com/methods/reactions.add Examples Slack.Reaction.add(client, name: &quot;thumbsup&quot;, timestamp: 1234567890.123456, channel: &quot;C1234567890&quot;)"},{"ref":"Slack.Reaction.html#get/2","title":"Slack.Reaction.get/2","type":"function","doc":"Get reactions for an iteam. https://api.slack.com/methods/reactions.get Examples Slack.Reaction.get(client, name: &quot;thumbsup&quot;, timestamp: 1234567890.123456, channel: &quot;C1234567890&quot;)"},{"ref":"Slack.Reaction.html#list/2","title":"Slack.Reaction.list/2","type":"function","doc":"List items reacted to by the user. https://api.slack.com/methods/reactions.list Examples Slack.Reaction.list(client)"},{"ref":"Slack.Reaction.html#remove/2","title":"Slack.Reaction.remove/2","type":"function","doc":"Remove a reaction from an item. https://api.slack.com/methods/reactions.remove Examples Slack.Reaction.remove(client, name: &quot;thumbsup&quot;, timestamp: 1234567890.123456, channel: &quot;C1234567890&quot;)"},{"ref":"Slack.Reminder.html","title":"Slack.Reminder","type":"module","doc":"\b\bFunctions for Reminders"},{"ref":"Slack.Reminder.html#add/2","title":"Slack.Reminder.add/2","type":"function","doc":"Create a reminder. https://api.slack.com/methods/reminders.add Examples Slack.Reminder.add(client, text: &quot;Walk the dog&quot;)"},{"ref":"Slack.Reminder.html#complete/2","title":"Slack.Reminder.complete/2","type":"function","doc":"Mark a reminder as completed. https://api.slack.com/methods/reminders.complete Examples Slack.Reminder.complete(client, reminder: &quot;Rm12345678&quot;)"},{"ref":"Slack.Reminder.html#delete/2","title":"Slack.Reminder.delete/2","type":"function","doc":"Delete a reminder. https://api.slack.com/methods/reminders.delete Examples Slack.Reminder.delete(client, reminder: &quot;Rm12345678&quot;)"},{"ref":"Slack.Reminder.html#info/2","title":"Slack.Reminder.info/2","type":"function","doc":"Get info on a reminder. https://api.slack.com/methods/reminders.info Examples Slack.Reminder.info(client, reminder: &quot;Rm12345678&quot;)"},{"ref":"Slack.Reminder.html#list/2","title":"Slack.Reminder.list/2","type":"function","doc":"List the user&#39;s reminders. https://api.slack.com/methods/reminders.list Examples Slack.Reminder.list(client)"},{"ref":"Slack.Request.html","title":"Slack.Request","type":"module","doc":""},{"ref":"Slack.Request.html#defget/1","title":"Slack.Request.defget/1","type":"macro","doc":"\b\bDefine a method method that makes a GET request to the module&#39;s base endpoint plus the method name: e.g. baseEndpoint.methodName."},{"ref":"Slack.Request.html#defpost/1","title":"Slack.Request.defpost/1","type":"macro","doc":"\b\bDefine a method method that makes a POST request to the module&#39;s base endpoint plus the method name: e.g. baseEndpoint.methodName."},{"ref":"Slack.Request.html#defrequest/2","title":"Slack.Request.defrequest/2","type":"macro","doc":"\b\bDefine a method method that makes a request (the block must return a call to an HTTPoison request method). The body of a successful response will be pattern matched against Slack&#39;s standard %{&quot;ok&quot; =&gt; true} message format, and will return {:ok, body} when the body matches %{&quot;ok&quot; =&gt; true}, or {:error, response} otherwise. In the case of an actual failed request, {:error, HTTPoison.Error.t} will be returned."},{"ref":"Slack.Search.html","title":"Slack.Search","type":"module","doc":"\b\bFunctions for searching"},{"ref":"Slack.Search.html#all/2","title":"Slack.Search.all/2","type":"function","doc":"Search messages and files. https://api.slack.com/methods/search.all Examples Slack.Search.all(client, query: &quot;My query&quot;)"},{"ref":"Slack.Search.html#files/2","title":"Slack.Search.files/2","type":"function","doc":"Search files. https://api.slack.com/methods/search.files Examples Slack.Search.files(client, query: &quot;My query&quot;)"},{"ref":"Slack.Search.html#messages/2","title":"Slack.Search.messages/2","type":"function","doc":"Search messages. https://api.slack.com/methods/search.messages Examples Slack.Search.messages(client, query: &quot;My query&quot;)"},{"ref":"Slack.Star.html","title":"Slack.Star","type":"module","doc":"\b\bFunctions for working with starred items"},{"ref":"Slack.Star.html#add/2","title":"Slack.Star.add/2","type":"function","doc":"Add a star to an item. https://api.slack.com/methods/stars.add Examples Slack.Star.add(client, channel: &quot;C1234567890&quot;)"},{"ref":"Slack.Star.html#list/2","title":"Slack.Star.list/2","type":"function","doc":"Lists items starred by the user. https://api.slack.com/methods/stars.list Examples Slack.Star.list(client)"},{"ref":"Slack.Star.html#remove/2","title":"Slack.Star.remove/2","type":"function","doc":"Remove a star from an item. Star messages and files. https://api.slack.com/methods/stars.remove Examples Slack.Star.remove(client, channel: &quot;C1234567890&quot;)"},{"ref":"Slack.Team.html","title":"Slack.Team","type":"module","doc":"\b\bFunctions for working with a Slack team"},{"ref":"Slack.Team.html#accessLogs/2","title":"Slack.Team.accessLogs/2","type":"function","doc":"Get access logs for a team. https://api.slack.com/methods/team.accessLogs Examples Slack.Team.accessLogs(client)"},{"ref":"Slack.Team.html#billableInfo/2","title":"Slack.Team.billableInfo/2","type":"function","doc":"Get billabale information for user or users on a team. https://api.slack.com/methods/team.billableInfo Examples Slack.Team.billableInfo(client, user: &quot;U1234567890&quot;)"},{"ref":"Slack.Team.html#info/2","title":"Slack.Team.info/2","type":"function","doc":"Get basic team info. https://api.slack.com/methods/team.info Examples Slack.Team.info(client)"},{"ref":"Slack.Team.html#integrationLogs/2","title":"Slack.Team.integrationLogs/2","type":"function","doc":"Get integration activity logs for the team. https://api.slack.com/methods/team.integrationLogs Examples Slack.Team.integrationLogs(client)"},{"ref":"Slack.Team.Profile.html","title":"Slack.Team.Profile","type":"module","doc":"\b\bFunctions for team profiles"},{"ref":"Slack.Team.Profile.html#get/2","title":"Slack.Team.Profile.get/2","type":"function","doc":"Get the profile field definitions for the team. https://api.slack.com/methods/team.profile.get Examples Slack.Team.Profile.get(client)"},{"ref":"Slack.User.html","title":"Slack.User","type":"module","doc":"Functions for working with Slack users"},{"ref":"Slack.User.html#getPresence/2","title":"Slack.User.getPresence/2","type":"function","doc":"Get information about a user&#39;s presence. https://api.slack.com/methods/users.getPresence Examples Slack.User.getPresence(client, user: &quot;U1234567890&quot;)"},{"ref":"Slack.User.html#identity/2","title":"Slack.User.identity/2","type":"function","doc":"Get the token holder&#39;s identity. https://api.slack.com/methods/users.identity Examples Slack.User.identity(client)"},{"ref":"Slack.User.html#info/2","title":"Slack.User.info/2","type":"function","doc":"Get information about a user. https://api.slack.com/methods/users.info Examples Slack.User.info(client, user: &quot;U1234567890&quot;)"},{"ref":"Slack.User.html#list/2","title":"Slack.User.list/2","type":"function","doc":"List users on a team. https://api.slack.com/methods/users.list Examples Slack.User.list(client)"},{"ref":"Slack.User.html#setActive/2","title":"Slack.User.setActive/2","type":"function","doc":"Let the messaging server know the user is active. https://api.slack.com/methods/users.setActive Examples Slack.User.setActive(client)"},{"ref":"Slack.User.html#setPresence/2","title":"Slack.User.setPresence/2","type":"function","doc":"Set the calling user&#39;s presence. https://api.slack.com/methods/users.setPresence Examples Slack.User.setPresence(client, presence: &quot;away&quot;)"},{"ref":"Slack.User.Profile.html","title":"Slack.User.Profile","type":"module","doc":"\b\bFunctions for working with user profiles"},{"ref":"Slack.User.Profile.html#get/2","title":"Slack.User.Profile.get/2","type":"function","doc":"Get the profile information of a user. https://api.slack.com/methods/users.profile.get Examples Slack.User.Profile.get(client, user: &quot;U1234567890&quot;)"},{"ref":"Slack.User.Profile.html#set/2","title":"Slack.User.Profile.set/2","type":"function","doc":"Set the profile information of a user. https://api.slack.com/methods/users.profile.set Examples Slack.User.Profile.set(client, user: &quot;U1234567890&quot;, name: &quot;Name&quot;)"},{"ref":"Slack.UserGroup.html","title":"Slack.UserGroup","type":"module","doc":"\b\bFunctions for a team&#39;s User Groups"},{"ref":"Slack.UserGroup.html#create/2","title":"Slack.UserGroup.create/2","type":"function","doc":"Create a new user group. https://api.slack.com/methods/usergroups.create Examples Slack.UserGroup.create(client, name: &quot;usergroup&quot;)"},{"ref":"Slack.UserGroup.html#disable/2","title":"Slack.UserGroup.disable/2","type":"function","doc":"Disable a user group. https://api.slack.com/methods/usergroups.disable Examples Slack.UserGroup.disable(client, usergroup: &quot;S0604QSJC&quot;)"},{"ref":"Slack.UserGroup.html#enable/2","title":"Slack.UserGroup.enable/2","type":"function","doc":"Enable a user group. https://api.slack.com/methods/usergroups.enable Examples Slack.UserGroup.enable(client, usergroup: &quot;S0604QSJC&quot;)"},{"ref":"Slack.UserGroup.html#list/2","title":"Slack.UserGroup.list/2","type":"function","doc":"List user groups for the team. https://api.slack.com/methods/usergroups.list Examples Slack.UserGroup.list(client)"},{"ref":"Slack.UserGroup.html#update/2","title":"Slack.UserGroup.update/2","type":"function","doc":"Update a user group. https://api.slack.com/methods/usergroups.update Examples Slack.UserGroup.update(client, usergroup: &quot;S0604QSJC&quot;, name: &quot;newname&quot;)"},{"ref":"Slack.UserGroup.User.html","title":"Slack.UserGroup.User","type":"module","doc":"\b\bFunctions for working with users in user groups"},{"ref":"Slack.UserGroup.User.html#list/2","title":"Slack.UserGroup.User.list/2","type":"function","doc":"List users in a usergroup. https://api.slack.com/methods/usergroups.users.list Examples Slack.UserGroup.list(client, usergroup: &quot;S0604QSJC&quot;)"},{"ref":"Slack.UserGroup.User.html#update/2","title":"Slack.UserGroup.User.update/2","type":"function","doc":"Update the list of users in a user group. https://api.slack.com/methods/usergroups.users.update Examples Slack.UserGroup.update( client, usergroup: &quot;S0604QSJC&quot;, user: &quot;U060R4BJ4,U060RNRCZ&quot;)"},{"ref":"contributing.html","title":"Contributing","type":"extras","doc":"Contributing This document outlines the basic guidelines for contributing to slack_ex, and also serves as a reminder for its main contributor, should they forget what to do when they need to add new API methods 😰"},{"ref":"contributing.html#new-api-methods","title":"Contributing - New API Methods","type":"extras","doc":"Let&#39;s say that Slack decides to add new functionality where users can (legally) add music tracks that play on a loop while users are in a Slack channel. They forget to add methods for disabling these tracks, so the only methods provided are tracks.addToChannel and tracks.upload. In order to support these methods, we&#39;ll create a Slack.Track module that exposes addToChannel and upload functions: defmodule Slack.Track do @moduledoc &quot;&quot;&quot; Functions for adding and uploading music tracks &quot;&quot;&quot; @base &quot;tracks&quot; use Slack.Request @doc &quot;&quot;&quot; Add an existing track to a channel. https://api.slack.com/methods/tracks.addToChannel ## Examples Slack.client(token) |&gt; Slack.Track.addToChannel(channel: &quot;C1234567890&quot;, track: &quot;T1234567890&quot;) &quot;&quot;&quot; @spec addToChannel(Slack.Client.t, Keyword.t) :: Slack.response defpost :addToChannel @doc &quot;&quot;&quot; Upload a new track. https://api.slack.com/methods/tracks.upload ## Examples Slack.client(token) |&gt; Slack.Track.upload(notes: &quot;BAG,BAG,GGGGAAAA,BAG&quot;) # &quot;Hot Cross Buns&quot; &quot;&quot;&quot; @spec upload(Slack.Client.t, Keyword.t) :: Slack.response defpost :upload end And that&#39;s it! The macro defpost (you can use defget when you&#39;re not changing anything) does all the work for us, creating a function with the given name that does all of the fancy pattern matching we need in order to determine a successful API method call."},{"ref":"license.html","title":"LICENSE","type":"extras","doc":"Copyright (c) 2016 Jonathan Clem Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE."}]